Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/fo/pi.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/fo/pi.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/fo/pi.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -46,5 +46,5 @@
   <refpurpose>Sets background color for an image</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo background-color</tag> PI before or
+    <para>Use the <tag class="xmlpi">dbfo background-color</tag> PI before or
       after an image (<tag>graphic</tag>, <tag>inlinegraphic</tag>,
       <tag>imagedata</tag>, or <tag>videodata</tag> element) as a
@@ -81,5 +81,5 @@
   <refpurpose>Sets background color on a table row or table cell</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo bgcolor</tag> PI as child of a table row
+    <para>Use the <tag class="xmlpi">dbfo bgcolor</tag> PI as child of a table row
       or cell to set a background color for that table row or cell.</para>
   </refdescription>
@@ -113,5 +113,5 @@
   <refpurpose>Specifies float behavior for a sidebar</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo float-type</tag> PI to specify the float
+    <para>Use the <tag class="xmlpi">dbfo float-type</tag> PI to specify the float
       behavior for a <tag>sidebar</tag> (to cause the sidebar to be
       displayed as a marginal note).</para>
@@ -153,5 +153,5 @@
   <refpurpose>Specifies presentation style for a glossary</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo glossary-presentation</tag> PI as a child of
+    <para>Use the <tag class="xmlpi">dbfo glossary-presentation</tag> PI as a child of
       a <tag>glossary</tag> to control its presentation style.</para>
   </refdescription>
@@ -192,5 +192,5 @@
   <refpurpose>Specifies presentation style for a glosslist</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo glosslist-presentation</tag> PI as a child of
+    <para>Use the <tag class="xmlpi">dbfo glosslist-presentation</tag> PI as a child of
       a <tag>glosslist</tag> to control its presentation style.</para>
   </refdescription>
@@ -232,5 +232,5 @@
     glosslist</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo glossterm-width</tag> PI as a child of a
+    <para>Use the <tag class="xmlpi">dbfo glossterm-width</tag> PI as a child of a
       <tag>glossary</tag> or <tag>glosslist</tag> to specify the
       width for output of <tag>glossterm</tag> instances in the
@@ -271,5 +271,5 @@
     figure, or equation</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo keep-together</tag> PI as a child of a
+    <para>Use the <tag class="xmlpi">dbfo keep-together</tag> PI as a child of a
       formal object (<tag>table</tag>, <tag>example</tag>,
       <tag>figure</tag>, or <tag>equation</tag>) or their informal
@@ -314,5 +314,5 @@
   <refpurpose>Specifies the label width for a qandaset</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo label-width</tag> PI as a child of a
+    <para>Use the <tag class="xmlpi">dbfo label-width</tag> PI as a child of a
       <tag>qandaset</tag> to specify the width of labels.</para>
   </refdescription>
@@ -346,5 +346,5 @@
   <refpurpose>Specifies interval for lines numbers in verbatims</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo linenumbering.everyNth</tag> PI as a child
+    <para>Use the <tag class="xmlpi">dbfo linenumbering.everyNth</tag> PI as a child
       of a âverbatimâ element â <tag>programlisting</tag>,
       <tag>screen</tag>, <tag>synopsis</tag> â to specify
@@ -384,5 +384,5 @@
   <refpurpose>Specifies separator text for line numbers in verbatims</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo linenumbering.separator</tag> PI as a child
+    <para>Use the <tag class="xmlpi">dbfo linenumbering.separator</tag> PI as a child
       of a âverbatimâ element â <tag>programlisting</tag>,
       <tag>screen</tag>, <tag>synopsis</tag> â to specify
@@ -421,5 +421,5 @@
   <refpurpose>Specifies width for line numbers in verbatims</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo linenumbering.width</tag> PI as a child
+    <para>Use the <tag class="xmlpi">dbfo linenumbering.width</tag> PI as a child
       of a âverbatimâ element â <tag>programlisting</tag>,
       <tag>screen</tag>, <tag>synopsis</tag> â to specify
@@ -459,5 +459,5 @@
     segmentedlist</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo list-presentation</tag> PI as a child of
+    <para>Use the <tag class="xmlpi">dbfo list-presentation</tag> PI as a child of
       a <tag>variablelist</tag> or <tag>segmentedlist</tag> to
       control the presentation style for the list (to cause it, for
@@ -513,5 +513,5 @@
   <refpurpose>Specifies the width of a horizontal simplelist</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo list-width</tag> PI as a child of a
+    <para>Use the <tag class="xmlpi">dbfo list-width</tag> PI as a child of a
       <tag>simplelist</tag> whose <tag class="attribute">class</tag>
       value is <literal>horizontal</literal>, to specify the width
@@ -542,5 +542,5 @@
   <refpurpose>Specifies the orientation for table row or cell</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo orientation</tag> PI as a child of an
+    <para>Use the <tag class="xmlpi">dbfo orientation</tag> PI as a child of an
       <tag>table</tag> row or cell to specify the orientation
       (rotation) for the row or cell.</para>
@@ -571,5 +571,5 @@
   <refpurpose>Specifies if an <tag>equation</tag> or <tag>example</tag> goes across full page width</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo pgwide</tag> PI as a child of an
+    <para>Use the <tag class="xmlpi">dbfo pgwide</tag> PI as a child of an
       <tag>equation</tag> or <tag>example</tag> to specify that the
       content should rendered across the full width of the page.</para>
@@ -610,5 +610,5 @@
     <tag>row</tag></refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo rotated-width</tag> PI as a child of an
+    <para>Use the <tag class="xmlpi">dbfo rotated-width</tag> PI as a child of an
       <tag>entry</tag> or <tag>row</tag> instance to specify the
       width of that the <tag>entry</tag> or <tag>row</tag>; or
@@ -640,5 +640,5 @@
   <refpurpose>Specifies the width of a sidebar</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo sidebar-width</tag> PI as a child of a
+    <para>Use the <tag class="xmlpi">dbfo sidebar-width</tag> PI as a child of a
       <tag>sidebar</tag> to specify the width of the sidebar.</para>
   </refdescription>
@@ -717,5 +717,5 @@
     output</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo table-width</tag> PI as a child or
+    <para>Use the <tag class="xmlpi">dbfo table-width</tag> PI as a child or
       sibling of a <tag>table</tag>, or as a child of an
       <tag>informaltable</tag>, <tag>entrybl</tag>, or
@@ -752,5 +752,5 @@
   <refpurpose>Specifies the term width for a variablelist</refpurpose>
   <refdescription>
-    <para>Use the <tag>dbfo term-width</tag> PI as a child of a
+    <para>Use the <tag class="xmlpi">dbfo term-width</tag> PI as a child of a
       <tag>variablelist</tag> to specify the width for
       <tag>term</tag> output.</para>
@@ -783,7 +783,7 @@
 
 <doc:pi name="dbfo_toc" xmlns="">
-  <refpurpose>Species whether a TOC should be generated for a qandaset</refpurpose>
-  <refdescription>
-    <para>Use the <tag>dbfo toc</tag> PI as a child of a
+  <refpurpose>Specifies whether a TOC should be generated for a qandaset</refpurpose>
+  <refdescription>
+    <para>Use the <tag class="xmlpi">dbfo toc</tag> PI as a child of a
       <tag>qandaset</tag> to specify whether a table of contents
       (TOC) is generated for the <tag>qandaset</tag>.</para>
@@ -843,5 +843,5 @@
         </listitem>
       </varlistentry>
-      <varlistentry><term>space-before"<replaceable>n</replaceable>"</term>
+      <varlistentry><term>space-before="<replaceable>n</replaceable>"</term>
         <listitem>
           <para>The amount of extra vertical space to add (including units)</para>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/fo/table.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/fo/table.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/fo/table.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -465,14 +465,9 @@
     <xsl:attribute name="table-layout">fixed</xsl:attribute>
   </xsl:if>
-
-  <xsl:if test="count(preceding-sibling::tgroup) = 0">
-    <!-- If this is the first tgroup, output the width attribute for the -->
-    <!-- surrounding fo:table. (If this isn't the first tgroup, trying   -->
-    <!-- to output the attribute will cause an error.)                   -->
+ 
     <xsl:attribute name="width">
       <xsl:value-of select="$table.width"/>
     </xsl:attribute>
-  </xsl:if>
-
+ 
   <xsl:choose>
     <xsl:when test="$use.extensions != 0
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/lib/lib.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/lib/lib.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/lib/lib.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -11,5 +11,5 @@
 
      ******************************************************************** -->
-<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://icl.com/saxon" xmlns:ssb="http://sideshowbarker.net/ns" xmlns:dyn="http://exslt.org/dynamic" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:src="http://nwalsh.com/xmlns/litprog/fragment" xmlns="http://docbook.org/ns/docbook" exclude-result-prefixes="src" version="1.0">
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
 
 <xsl:template name="dot.count">
@@ -331,5 +331,5 @@
     <xsl:param name="string"/>
     <xsl:if test="$string">
-      <ssb:token><xsl:value-of select="substring($string, 1, 1)"/></ssb:token>
+      <ssb:token xmlns:ssb="http://sideshowbarker.net/ns"><xsl:value-of select="substring($string, 1, 1)"/></ssb:token>
       <xsl:call-template name="str.tokenize.keep.delimiters-characters">
         <xsl:with-param name="string" select="substring($string, 2)"/>
@@ -343,5 +343,5 @@
     <xsl:choose>
       <xsl:when test="not($delimiter)">
-        <ssb:token><xsl:value-of select="$string"/></ssb:token>
+        <ssb:token xmlns:ssb="http://sideshowbarker.net/ns"><xsl:value-of select="$string"/></ssb:token>
       </xsl:when>
       <xsl:when test="contains($string, $delimiter)">
@@ -389,61 +389,5 @@
       </xsl:choose>
     </xsl:template>
-
   
-    <xsl:template name="apply-character-map">
-      <xsl:param name="content"/>
-      <xsl:param name="map.contents"/>
-      <xsl:variable name="replaced_text">
-        <xsl:call-template name="string.subst">
-          <xsl:with-param name="string" select="$content"/>
-          <xsl:with-param name="target" select="$map.contents[1]/@character"/>
-          <xsl:with-param name="replacement" select="$map.contents[1]/@string"/>
-        </xsl:call-template>
-      </xsl:variable>
-      <xsl:choose>
-        <xsl:when test="$map.contents[2]">
-          <xsl:call-template name="apply-character-map">
-            <xsl:with-param name="content" select="$replaced_text"/>
-            <xsl:with-param name="map.contents" select="$map.contents[position() &gt; 1]"/>
-          </xsl:call-template>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:value-of select="$replaced_text"/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </xsl:template>
-
-  
-  <xsl:template name="read-character-map">
-    <xsl:param name="use.subset"/>
-    <xsl:param name="subset.profile"/>
-    <xsl:param name="uri"/>
-    <xsl:choose>
-      <xsl:when test="$use.subset != 0">
-        <!-- use a subset of the character map instead of the full map -->
-        <xsl:choose>
-          <!-- xsltproc and Xalan both support dyn:evaluate() -->
-          <xsl:when test="function-available('dyn:evaluate')">
-            <xsl:copy-of select="document($uri)//*[local-name()='output-character']                                  [dyn:evaluate($subset.profile)]"/>
-          </xsl:when>
-          <!-- Saxon has its own evaluate() & doesn't support dyn:evaluate() -->
-          <xsl:when test="function-available('saxon:evaluate')">
-            <xsl:copy-of select="document($uri)//*[local-name()='output-character']                                  [saxon:evaluate($subset.profile)]"/>
-          </xsl:when>
-          <xsl:otherwise>
-            <xsl:message terminate="yes">
-Error: To process character-map subsets, you must use an XSLT engine
-that supports the evaluate() XSLT extension function. Your XSLT engine
-does not support it.
-</xsl:message>
-          </xsl:otherwise>
-        </xsl:choose>
-        </xsl:when>
-        <xsl:otherwise>
-          <!-- value of $use.subset is non-zero, so use the full map -->
-        <xsl:copy-of select="document($uri)//*[local-name()='output-character']"/>
-      </xsl:otherwise>
-    </xsl:choose>
-  </xsl:template>
 <xsl:template name="count.uri.path.depth">
   <xsl:param name="filename" select="''"/>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/profiling/xsl2profile.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/profiling/xsl2profile.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/profiling/xsl2profile.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -82,5 +82,5 @@
 </xsl:template>
 
-<xsl:template match="xsl:template[@name='hhc-main' or @name='hhp-main'] | xsl:variable[@name='raw.help.title']">
+<xsl:template match="xsl:template[@name='hhc-main' or @name='hhp-main' or @name='etoc'] | xsl:variable[@name='raw.help.title']">
   <xsl:copy>
     <xsl:copy-of select="@*"/>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/docbook.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/docbook.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/docbook.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -94,5 +94,5 @@
   </xsl:message>
 
-  <span xmlns:saxon="http://icl.com/saxon" class="ERROR">
+  <span style="color: red">
     <xsl:text>&lt;</xsl:text>
     <xsl:value-of select="name(.)"/>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/formal.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/formal.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/formal.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -104,7 +104,5 @@
     <div class="{$class}">
       <xsl:if test="$spacing.paras != 0"><p/></xsl:if>
-      <xsl:call-template name="anchor">
-        <xsl:with-param name="conditional" select="0"/>
-      </xsl:call-template>
+      <xsl:call-template name="anchor"/>
       <xsl:apply-templates/>
   
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/glossary.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/glossary.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/glossary.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -50,6 +50,9 @@
         <xsl:apply-templates select="(glossdiv[1]/preceding-sibling::*)"/>
       </xsl:when>
+      <xsl:when test="glossentry">
+        <xsl:apply-templates select="(glossentry[1]/preceding-sibling::*)"/>
+      </xsl:when>
       <xsl:otherwise>
-        <xsl:apply-templates select="(glossentry[1]/preceding-sibling::*)"/>
+        <xsl:apply-templates/>
       </xsl:otherwise>
     </xsl:choose>
@@ -59,5 +62,5 @@
         <xsl:apply-templates select="glossdiv"/>
       </xsl:when>
-      <xsl:otherwise>
+      <xsl:when test="glossentry">
         <dl>
           <xsl:choose>
@@ -72,4 +75,7 @@
           </xsl:choose>
         </dl>
+      </xsl:when>
+      <xsl:otherwise>
+        <!-- empty glossary -->
       </xsl:otherwise>
     </xsl:choose>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/graphics.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/graphics.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/graphics.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -1077,12 +1077,5 @@
 
 <xsl:template match="imageobject">
-  <xsl:choose>
-    <xsl:when xmlns:svg="http://www.w3.org/2000/svg" test="svg:*">
-      <xsl:apply-templates/>
-    </xsl:when>
-    <xsl:otherwise>
-      <xsl:apply-templates select="imagedata"/>
-    </xsl:otherwise>
-  </xsl:choose>
+  <xsl:apply-templates select="imagedata"/>
 </xsl:template>
 
@@ -1095,4 +1088,13 @@
 
   <xsl:choose>
+    <!-- Handle MathML and SVG markup in imagedata -->
+    <xsl:when xmlns:mml="http://www.w3.org/1998/Math/MathML" test="mml:*">
+      <xsl:apply-templates/>
+    </xsl:when>
+    
+    <xsl:when xmlns:svg="http://www.w3.org/2000/svg" test="svg:*">
+      <xsl:apply-templates/>
+    </xsl:when>
+
     <xsl:when test="@format='linespecific'">
       <xsl:choose>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/highlight.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/highlight.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/highlight.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -19,29 +19,29 @@
 
 <xsl:template match="xslthl:string">
-  <b class="hl-string"><i><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></i></b>
+  <b class="hl-string"><i style="color:red"><xsl:apply-templates/></i></b>
 </xsl:template>
 
 <xsl:template match="xslthl:comment">
-  <i class="hl-comment"><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></i>
+  <i class="hl-comment" style="color: silver"><xsl:apply-templates/></i>
 </xsl:template>
 
 <xsl:template match="xslthl:tag">
-  <b class="hl-tag"><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></b>
+  <b class="hl-tag" style="color: blue"><xsl:apply-templates/></b>
 </xsl:template>
 
 <xsl:template match="xslthl:attribute">
-  <span class="hl-attribute"><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></span>
+  <span class="hl-attribute" style="color: blue"><xsl:apply-templates/></span>
 </xsl:template>
 
 <xsl:template match="xslthl:value">
-  <span class="hl-value"><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></span>
+  <span class="hl-value" style="color: blue"><xsl:apply-templates/></span>
 </xsl:template>
 
 <xsl:template match="xslthl:html">
-  <b><i><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></i></b>
+  <b><i style="color: red"><xsl:apply-templates/></i></b>
 </xsl:template>
 
 <xsl:template match="xslthl:xslt">
-  <b><span xmlns:saxon="http://icl.com/saxon" class="ERROR"><xsl:apply-templates/></span></b>
+  <b style="color: blue"><xsl:apply-templates/></b>
 </xsl:template>
 
@@ -50,4 +50,3 @@
 </xsl:template>
 
-
 </xsl:stylesheet>
Index: BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/inline.xsl
===================================================================
--- BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/inline.xsl	(revision a6966fa8712cec241deb9329e43f671795135e2a)
+++ BOOK/stylesheets/lfs-xsl/docbook-xsl-snapshot/xhtml/inline.xsl	(revision 9642843445e7bc7989dbb851df6a5ed026d21a22)
@@ -82,5 +82,5 @@
 
                   <xsl:choose>
-                    <xsl:when test="$node/@xlink.title">
+                    <xsl:when test="$node/@xlink:title">
                       <xsl:attribute name="title">
                         <xsl:value-of select="$node/@xlink:title"/>
@@ -118,5 +118,5 @@
                 <xsl:value-of select="$xhref"/>
               </xsl:attribute>
-              <xsl:if test="$node/@xlink.title">
+              <xsl:if test="$node/@xlink:title">
                 <xsl:attribute name="title">
                   <xsl:value-of select="$node/@xlink:title"/>
